/*****************************************************************************
 *	aisa10w.c
 *
 *	aISA-P10
 *
 *	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
 *
 *	Date 1998/05/20
 *
 *****************************************************************************/
#include <windows.h>
#include <tchar.h>
#include "aisa10w.h"	// aISA-P10

//---------- X^eBbN֐ & X^eBbNϐ(萔)	----------------------
static BOOL Aisa10wGetDllExportFunc();
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[pϐ
static FARPROC pAisa10GetVersion;
static FARPROC pAisa10Create;
static FARPROC pAisa10Close;
static FARPROC pAisa10GetResource;
static FARPROC pAisa10InPort;
static FARPROC pAisa10OutPort;
static FARPROC pAisa10GetLastError;

BOOL Aisa10wDllOpen ( void )
/*****************************************************************************
 * @\  aisa10.dll[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL != NULL) {
		return FALSE;
	}
	hDLL = (HMODULE)LoadLibrary(AISA10_DLL_NAME);
	if (hDLL == NULL) {
		return FALSE;
	}
	if (Aisa10wGetDllExportFunc() == FALSE) {
		// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		Aisa10wDllClose();
		return FALSE;
	}
	return TRUE;
}

BOOL Aisa10wDllClose ( void )
/*****************************************************************************
 * @\  aisa10.dllA[h
 * 	 Ȃ
 * ߒl	 TRUE  --- 
 *		 FALSE --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	if (FreeLibrary(hDLL) == TRUE) {
		hDLL = NULL;
		return TRUE;
	}
	return FALSE;
}

BOOL Aisa10wGetVersion ( PDWORD pdwDllVer, PDWORD pdwDrvVer )
/*****************************************************************************
 * @\  aISA-P10DLL,Driver̃o[Wԍ擾
 * 	 pdwDllVer --- DLLo[Wԍi[AhX
 *		 pdwDrvVer --- Drivero[Wԍi[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa10GetVersion)(pdwDllVer, pdwDrvVer);
}

BOOL Aisa10wCreate ( PWORD pwLogSlot )
/*****************************************************************************
 * @\  aISA-P10̔Cӂ̃foCX̎gp錾
 * 	 pwLogSlot	--- gpfoCXi[AhX
 * ߒl	 TRUE		--- 
 *		 FALSE		--- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa10Create)(pwLogSlot);
}

BOOL Aisa10wClose ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P10̔Cӂ̃foCX̎gpJ
 * 	 wLogSlot  --- gpfoCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa10Close)(wLogSlot);
}

BOOL Aisa10wGetResource ( WORD wLogSlot, PAISA10R pResInfo )
/*****************************************************************************
 * @\  wfoCX̃\[X擾
 * 	 wLogSlot --- ׂfoCX
 *		 pResInfo --- \[Xi[\̂̃AhX
 * ߒl	 TRUE	  --- 
 *		 FALSE	  --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa10GetResource)(wLogSlot, pResInfo);
}

BOOL Aisa10wInPort ( WORD wLogSlot, DWORD dwPort, PBYTE pbInValue )
/*****************************************************************************
 * @\  Cӂ̃|[gf[^
 * 	 wLogSlot  --- ͂foCX
 *		 dwPort	   --- ͂|[g
 *		 pbInValue --- ̓f[^i[AhX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa10InPort)(wLogSlot, dwPort, pbInValue);
}

BOOL Aisa10wOutPort ( WORD wLogSlot, DWORD dwPort, BYTE bOutValue )
/*****************************************************************************
 * @\  Cӂ̃|[gփf[^o
 * 	 wLogSlot  --- o͂foCX
 *		 dwPort	   --- o͂|[g
 *		 bOutValue --- o̓f[^
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return FALSE;
	}
	return (*pAisa10OutPort)(wLogSlot, dwPort, bOutValue);
}

DWORD Aisa10wGetLastError ( WORD wLogSlot )
/*****************************************************************************
 * @\  aISA-P10̃G[R[h
 * 	 wLogSlot  --- G[foCX
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *****************************************************************************/
{
	if (hDLL == NULL) {
		return AISA10_ERR_WRAPDLL;
	}
	return (*pAisa10GetLastError)(wLogSlot);
}

static BOOL Aisa10wGetDllExportFunc ( void )
/*---------------------------------------------------------------------------
 * 	 DLLGNX|[g֐AhX̎擾
 * 	 Ȃ
 * ߒl	 TRUE	   --- 
 *		 FALSE	   --- s
 *---------------------------------------------------------------------------*/
{
	// Aisa10GetVersion ̃AhX擾
	pAisa10GetVersion = GetProcAddress(hDLL, _T("Aisa10GetVersion"));
	if (pAisa10GetVersion == NULL) {
		return FALSE;
	}

	// Aisa10Create ̃AhX擾
	pAisa10Create = GetProcAddress(hDLL, _T("Aisa10Create"));
	if (pAisa10Create == NULL) {
		return FALSE;
	}

	// Aisa10Close ̃AhX擾
	pAisa10Close = GetProcAddress(hDLL, _T("Aisa10Close"));
	if (pAisa10Close == NULL) {
		return FALSE;
	}

	// Aisa10GetResource ̃AhX擾
	pAisa10GetResource = GetProcAddress(hDLL, _T("Aisa10GetResource"));
	if (pAisa10GetResource == NULL) {
		return FALSE;
	}

	// Aisa10InPort ̃AhX擾
	pAisa10InPort = GetProcAddress(hDLL, _T("Aisa10InPort"));
	if (pAisa10InPort == NULL) {
		return FALSE;
	}

	// Aisa10OutPort ̃AhX擾
	pAisa10OutPort = GetProcAddress(hDLL, _T("Aisa10OutPort"));
	if (pAisa10OutPort == NULL) {
		return FALSE;
	}

	// Aisa10GetLastError ̃AhX擾
	pAisa10GetLastError = GetProcAddress(hDLL, _T("Aisa10GetLastError"));
	if (pAisa10GetLastError == NULL) {
		return FALSE;
	}
	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
